From: Andreas Gruenbacher <agruen@gnu.org>
Date: Fri, 6 Apr 2018 12:14:49 +0200
Subject: Fix arbitrary command execution in ed-style patches
Patch-mainline: yes
Git-commit: 123eaff0d5d1aebe128295959435b9ca5909c26d
References: bsc#1088420, savannah#53566, CVE-2018-1000156

* src/pch.c (do_ed_script): Write ed script to a temporary file instead
of piping it to ed: this will cause ed to abort on invalid commands
instead of rejecting them and carrying on.
* tests/ed-style: New test case.
* tests/Makefile.am (TESTS): Add test case.

Backporting notes:
* Use create_file instead of make_tempfile.
* Use unlink instead of safe_unlink.
* Drop the test case.
---
 common.h |    1 
 patch.c  |    1 
 pch.c    |   89 +++++++++++++++++++++++++++++++++++++++++++++------------------
 3 files changed, 66 insertions(+), 25 deletions(-)

--- a/common.h
+++ b/common.h
@@ -154,6 +154,7 @@ XTERN char const *origbase;
 XTERN char const * volatile TMPINNAME;
 XTERN char const * volatile TMPOUTNAME;
 XTERN char const * volatile TMPPATNAME;
+XTERN char const * volatile TMPEDNAME;
 
 XTERN int volatile TMPINNAME_needs_removal;
 XTERN int volatile TMPOUTNAME_needs_removal;
--- a/patch.c
+++ b/patch.c
@@ -160,6 +160,7 @@ main (int argc, char **argv)
     TMPINNAME = make_temp ('i');
     TMPREJNAME = make_temp ('r');
     TMPPATNAME = make_temp ('p');
+    TMPEDNAME = make_temp ('e');
 
     /* parse switches */
     Argc = argc;
--- a/pch.c
+++ b/pch.c
@@ -33,6 +33,7 @@
 #undef XTERN
 #define XTERN
 #include <pch.h>
+#include <sys/wait.h>
 
 #define INITHUNKMAX 125			/* initial dynamic allocation size */
 
@@ -2008,24 +2009,27 @@ do_ed_script (char const *inname, char c
     static char const ed_program[] = ed_PROGRAM;
 
     register file_offset beginning_of_this_line;
-    register FILE *pipefp = 0;
     register size_t chars_read;
+    FILE *tmpfp = 0;
+    int tmpfd;
+    pid_t pid;
+
+    if (! dry_run && ! skip_rest_of_patch)
+      {
+	/* Write ed script to a temporary file.  This causes ed to abort on
+	   invalid commands such as when line numbers or ranges exceed the
+	   number of available lines.  When ed reads from a pipe, it rejects
+	   invalid commands and treats the next line as a new command, which
+	   can lead to arbitrary command execution.  */
+
+	tmpfd = create_file (TMPEDNAME, O_RDWR | O_BINARY | O_EXCL, (mode_t) 0);
+	if (tmpfd == -1)
+	  pfatal ("Can't create temporary file %s", quotearg (TMPEDNAME));
+	tmpfp = fdopen (tmpfd, "w+b");
+	if (! tmpfp)
+	  pfatal ("Can't open stream for file %s", quotearg (TMPEDNAME));
+      }
 
-    if (! dry_run && ! skip_rest_of_patch) {
-	int exclusive = *outname_needs_removal ? 0 : O_EXCL;
-	if (inerrno != ENOENT)
-	  {
-	    *outname_needs_removal = 1;
-	    copy_file (inname, outname, exclusive, instat.st_mode);
-	  }
-	sprintf (buf, "%s %s%s", ed_program,
-		 verbosity == VERBOSE ? "" : "- ",
-		 outname);
-	fflush (stdout);
-	pipefp = popen(buf, binary_transput ? "wb" : "w");
-	if (!pipefp)
-	  pfatal ("Can't open pipe to %s", quotearg (buf));
-    }
     for (;;) {
 	char ed_command_letter;
 	beginning_of_this_line = file_tell (pfp);
@@ -2036,14 +2040,14 @@ do_ed_script (char const *inname, char c
 	}
 	ed_command_letter = get_ed_command_letter (buf);
 	if (ed_command_letter) {
-	    if (pipefp)
-		if (! fwrite (buf, sizeof *buf, chars_read, pipefp))
+	    if (tmpfp)
+		if (! fwrite (buf, sizeof *buf, chars_read, tmpfp))
 		    write_fatal ();
 	    if (ed_command_letter != 'd' && ed_command_letter != 's') {
 	        p_pass_comments_through = true;
 		while ((chars_read = get_line ()) != 0) {
-		    if (pipefp)
-			if (! fwrite (buf, sizeof *buf, chars_read, pipefp))
+		    if (tmpfp)
+			if (! fwrite (buf, sizeof *buf, chars_read, tmpfp))
 			    write_fatal ();
 		    if (chars_read == 2  &&  strEQ (buf, ".\n"))
 			break;
@@ -2056,13 +2060,48 @@ do_ed_script (char const *inname, char c
 	    break;
 	}
     }
-    if (!pipefp)
+    if (!tmpfp)
       return;
-    if (fwrite ("w\nq\n", sizeof (char), (size_t) 4, pipefp) == 0
-	|| fflush (pipefp) != 0)
+    if (fwrite ("w\nq\n", sizeof (char), (size_t) 4, tmpfp) == 0
+	|| fflush (tmpfp) != 0)
       write_fatal ();
-    if (pclose (pipefp) != 0)
-      fatal ("%s FAILED", ed_program);
+
+    if (lseek (tmpfd, 0, SEEK_SET) == -1)
+      pfatal ("Can't rewind to the beginning of file %s", quotearg (TMPEDNAME));
+
+    if (! dry_run && ! skip_rest_of_patch) {
+	int exclusive = *outname_needs_removal ? 0 : O_EXCL;
+	*outname_needs_removal = 1;
+	if (inerrno != ENOENT)
+	  {
+	    *outname_needs_removal = 1;
+	    copy_file (inname, outname, exclusive, instat.st_mode);
+	  }
+	sprintf (buf, "%s %s%s", ed_program,
+		 verbosity == VERBOSE ? "" : "- ",
+		 outname);
+	fflush (stdout);
+
+	pid = fork();
+	if (pid == -1)
+	  pfatal ("Can't fork");
+	else if (pid == 0)
+	  {
+	    dup2 (tmpfd, 0);
+	    execl ("/bin/sh", "sh", "-c", buf, (char *) 0);
+	    _exit (2);
+	  }
+	else
+	  {
+	    int wstatus;
+	    if (waitpid (pid, &wstatus, 0) == -1
+	        || ! WIFEXITED (wstatus)
+		|| WEXITSTATUS (wstatus) != 0)
+	      fatal ("%s FAILED", ed_program);
+	  }
+    }
+
+    fclose (tmpfp);
 
     if (ofp)
       {
